local utils = require "utils"

if ngx.ctx.jasima_config.rewrite_disable then
    return
end

if ngx.header["Content-Type"] then
    local content_type = ngx.header["Content-Type"]:lower()
    if content_type:find("text/html") or
       content_type:find("text/css") or
       content_type:find("text/xml") or
       content_type:find("application/javascript") or
       content_type:find("application/json") or
       content_type:find("application/rss%+xml") or
       content_type:find("application/atom%+xml") or
       content_type:find("application/vnd%.mpegurl") or
       content_type:find("application/x%-mpegurl") then
        ngx.log(ngx.DEBUG, "Enabling rewrite due to content type " .. content_type)
        ngx.ctx.rewriting = true
        ngx.header["Content-Length"] = nil  -- We're rewriting the body so this has the wrong value if set
    end
end

if ngx.header["Location"] then
    if ngx.ctx.jasima_pool_map then
        local location = ngx.header["Location"]
        ngx.header["Location"] = location:gsub("//([%a%d%.-]+%.[%a%d-]+)/+", utils.get_mirror)
    end
end
